create or replace
PROCEDURE CCH_IMPORTA_FORNECEDOR_SAP
IS 
   V_CDPAIS      INTEGER;
   V_SGESTADO    INTEGER;
   V_FORNECEDOR  INTEGER;
   V_CDMUNICIPIO VARCHAR2(7);
BEGIN
   FOR C_FORNECEDOR IN 
       (SELECT /* FORNECEDOR */
               U.CDFORNECEDOR, U.NMRAZAOSOC, U.NMFANTFORNE, U.IDTPIJURFORN, U.NRINSJURFORN, U.NRINSESTFORN, U.IDTIPOFORN, U.IDFORMPGFORN, U.CDCSTDIG1ENT,
               U.IDSITUCADA, U.NRNOTAFORN, U.CDQUALIF, U.DTVALQUALIF, U.IDTPFORPGTFO, U.NRPARCPGTOFO, U.NRDIAPGFIXFO, U.IDUTDIAPGTFO,
               U.IDGERAFDTENT, U.IDFORNAUTO, 'P' AS IDENDEMISFOR, NVL(U.IDENDCFOPFOR, 'P') AS IDENDCFOPFOR, U.DTULTATUFORN, U.CDTIPOFORN, NVL(U.IDPRIPUBFORN, 'V') AS IDPRIPUBFORN, NVL(U.IDAGRUBOLFOR, 'N') AS IDAGRUBOLFOR, NVL(U.IDLIGEXTFORN, 'S') AS IDLIGEXTFORN,
               U.VRPERPIFORN, U.IDFORNINTER, U.NMCOMPRZSFOR, U.CDEXFORNECED, NVL(U.IDUTLALVFORN, 'N') AS IDUTLALVFORN, U.NRALVARAFORN, U.DTALVARAFORN,
               /* ENDEFORN */
               U.DSENDERECOP, U.CDPAISP, U.SGESTADOP, SUBSTR(U.CDMUNICIPIOP, 3, 5) AS CDMUNICIPIOP, U.CDCEPP, U.NMBAIRROP, U.EMAIL, U.IDTPENDEFORN, U.NRTELEFORN, U.NRRAMALFORN,
               U.NRFAXFORN, U.DTULTATUENFO, U.NMCONTFORN, U.DSCOMPENDFOR, U.OBSQUALFORNSAP,
               /* USR_SAP_FORNECEDOR */
               U.IDINTERFACE, U.TPINTERFACE
          FROM USR_SAP_FORNECEDOR U
         WHERE U.DTINTERFACEDEST IS NULL
         ORDER BY U.DTINTERFACEORI)
   LOOP

      SELECT COUNT(1) AS CDPAIS
        INTO V_CDPAIS
        FROM PAIS
       WHERE CDPAIS = C_FORNECEDOR.CDPAISP;

      IF V_CDPAIS > 0 THEN
         SELECT COUNT(1) AS SGESTADO
           INTO V_SGESTADO
           FROM ESTADO
          WHERE CDPAIS   = C_FORNECEDOR.CDPAISP
            AND SGESTADO = C_FORNECEDOR.SGESTADOP;

         IF V_SGESTADO > 0 THEN
            BEGIN
               SELECT MAX(CDMUNICIPIO) CDMUNICIPIO
                 INTO V_CDMUNICIPIO
                 FROM MUNICIPIO
                WHERE CDPAIS     = C_FORNECEDOR.CDPAISP
                  AND SGESTADO   = C_FORNECEDOR.SGESTADOP
                  AND CDMUNIEXPO = C_FORNECEDOR.CDMUNICIPIOP;

               IF V_CDMUNICIPIO IS NOT NULL THEN
                  SELECT COUNT(1) AS CDFORNECEDOR
                    INTO V_FORNECEDOR
                    FROM FORNECEDOR
                   WHERE CDFORNECED = C_FORNECEDOR.CDFORNECEDOR;

                  IF V_FORNECEDOR = 0 THEN
                     INSERT INTO FORNECEDOR
                        (CDFORNECED, NMRAZSOCFORN, NMFANTFORN, IDTPIJURFORN, NRINSJURFORN, NRINSESTFORN, IDTIPOFORN, IDFORMPGFORN, CDCSTDIG1ENT,
                         IDSITUCADA, NRNOTAFORN, CDQUALIF, DTVALQUALIF, CDFORMPGTO, IDTPFORPGTFO, NRPARCPGTOFO, NRDIAPGFIXFO, IDUTDIAPGTFO,
                         IDGERAFDTENT, IDFORNAUTO, IDENDEMISFOR, IDENDCFOPFOR, DTULTATUFORN, CDTIPOFORN, IDPRIPUBFORN, IDAGRUBOLFOR, IDLIGEXTFORN,
                         VRPERPIFORN, IDFORNINTER, NMCOMPRZSFOR, CDEXFORNECED, IDUTLALVFORN, NRALVARAFORN, DTALVARAFORN)
                     VALUES
                        (C_FORNECEDOR.CDFORNECEDOR, C_FORNECEDOR.NMRAZAOSOC, C_FORNECEDOR.NMFANTFORNE, C_FORNECEDOR.IDTPIJURFORN, C_FORNECEDOR.NRINSJURFORN, C_FORNECEDOR.NRINSESTFORN, C_FORNECEDOR.IDTIPOFORN, C_FORNECEDOR.IDFORMPGFORN, C_FORNECEDOR.CDCSTDIG1ENT,
                         C_FORNECEDOR.IDSITUCADA, C_FORNECEDOR.NRNOTAFORN, C_FORNECEDOR.CDQUALIF, C_FORNECEDOR.DTVALQUALIF, NULL, C_FORNECEDOR.IDTPFORPGTFO, C_FORNECEDOR.NRPARCPGTOFO, C_FORNECEDOR.NRDIAPGFIXFO, C_FORNECEDOR.IDUTDIAPGTFO,
                         C_FORNECEDOR.IDGERAFDTENT, C_FORNECEDOR.IDFORNAUTO, C_FORNECEDOR.IDENDEMISFOR, C_FORNECEDOR.IDENDCFOPFOR, C_FORNECEDOR.DTULTATUFORN, C_FORNECEDOR.CDTIPOFORN, C_FORNECEDOR.IDPRIPUBFORN, C_FORNECEDOR.IDAGRUBOLFOR, C_FORNECEDOR.IDLIGEXTFORN,
                         C_FORNECEDOR.VRPERPIFORN, C_FORNECEDOR.IDFORNINTER, C_FORNECEDOR.NMCOMPRZSFOR, C_FORNECEDOR.CDEXFORNECED, C_FORNECEDOR.IDUTLALVFORN, C_FORNECEDOR.NRALVARAFORN, C_FORNECEDOR.DTALVARAFORN);

                     /* Endereco principal */
                     INSERT INTO ENDEFORN
                        (CDFORNECED, DSENDEFORN, CDPAIS, SGESTADO, CDMUNICIPIO, NRCEPFORN,
                         NMBAIRFORN, DSEMAILFORN, IDTPENDEFORN, NRTELEFORN, NRRAMALFORN, NRFAXFORN,
                         DTULTATUENFO, NMCONTFORN, DSCOMPENDFOR)
                     VALUES
                        (C_FORNECEDOR.CDFORNECEDOR, C_FORNECEDOR.DSENDERECOP, C_FORNECEDOR.CDPAISP, C_FORNECEDOR.SGESTADOP, V_CDMUNICIPIO, C_FORNECEDOR.CDCEPP,
                         C_FORNECEDOR.NMBAIRROP, C_FORNECEDOR.EMAIL, 'P', C_FORNECEDOR.NRTELEFORN, C_FORNECEDOR.NRRAMALFORN, C_FORNECEDOR.NRFAXFORN,
                         C_FORNECEDOR.DTULTATUENFO, C_FORNECEDOR.NMCONTFORN, C_FORNECEDOR.DSCOMPENDFOR);


                     INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                     VALUES(C_FORNECEDOR.IDINTERFACE, 'I', 1, SYSDATE, 0, 'Proveedor '||C_FORNECEDOR.CDFORNECEDOR || ' - ' || C_FORNECEDOR.NMFANTFORNE ||' registrado con xito.');

                  ELSE
                     UPDATE FORNECEDOR SET NMRAZSOCFORN = C_FORNECEDOR.NMRAZAOSOC, NMFANTFORN = C_FORNECEDOR.NMFANTFORNE, IDTIPOFORN = C_FORNECEDOR.IDTIPOFORN, IDFORMPGFORN = C_FORNECEDOR.IDFORMPGFORN, CDCSTDIG1ENT = C_FORNECEDOR.CDCSTDIG1ENT,
                                           IDSITUCADA = C_FORNECEDOR.IDSITUCADA, NRNOTAFORN = C_FORNECEDOR.NRNOTAFORN, CDQUALIF = C_FORNECEDOR.CDQUALIF, DTVALQUALIF = C_FORNECEDOR.DTVALQUALIF, CDFORMPGTO = NULL, IDTPFORPGTFO = C_FORNECEDOR.IDTPFORPGTFO, NRPARCPGTOFO = C_FORNECEDOR.NRPARCPGTOFO, NRDIAPGFIXFO = C_FORNECEDOR.NRDIAPGFIXFO, IDUTDIAPGTFO = C_FORNECEDOR.IDUTDIAPGTFO,
                                           IDGERAFDTENT = C_FORNECEDOR.IDGERAFDTENT, IDFORNAUTO = C_FORNECEDOR.IDFORNAUTO, IDENDEMISFOR = C_FORNECEDOR.IDENDEMISFOR, IDENDCFOPFOR = C_FORNECEDOR.IDENDCFOPFOR, CDTIPOFORN = C_FORNECEDOR.CDTIPOFORN, IDPRIPUBFORN = C_FORNECEDOR.IDPRIPUBFORN, IDAGRUBOLFOR = C_FORNECEDOR.IDAGRUBOLFOR, IDLIGEXTFORN = C_FORNECEDOR.IDLIGEXTFORN,
                                           VRPERPIFORN = C_FORNECEDOR.VRPERPIFORN, IDFORNINTER = C_FORNECEDOR.IDFORNINTER, NMCOMPRZSFOR = C_FORNECEDOR.NMCOMPRZSFOR, CDEXFORNECED = C_FORNECEDOR.CDEXFORNECED, IDUTLALVFORN = C_FORNECEDOR.IDUTLALVFORN, NRALVARAFORN = C_FORNECEDOR.NRALVARAFORN, DTALVARAFORN = C_FORNECEDOR.DTALVARAFORN,
                                           NRINSESTFORN = C_FORNECEDOR.NRINSESTFORN
                      WHERE CDFORNECED = C_FORNECEDOR.CDFORNECEDOR;

                     UPDATE ENDEFORN SET DSENDEFORN = C_FORNECEDOR.DSENDERECOP, CDPAIS = C_FORNECEDOR.CDPAISP, SGESTADO = C_FORNECEDOR.SGESTADOP,
                                         CDMUNICIPIO = V_CDMUNICIPIO, NRCEPFORN = C_FORNECEDOR.CDCEPP, NMBAIRFORN = C_FORNECEDOR.NMBAIRROP, DSEMAILFORN = C_FORNECEDOR.EMAIL
                      WHERE CDFORNECED = C_FORNECEDOR.CDFORNECEDOR;

                     INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                     VALUES (C_FORNECEDOR.IDINTERFACE, 'A', 1, SYSDATE, 0, 'La actualizacin de proveedor '|| C_FORNECEDOR.CDFORNECEDOR  || ' - ' ||  C_FORNECEDOR.NMFANTFORNE  || ' registrada con xito.');
                  END IF;

                  UPDATE USR_SAP_FORNECEDOR SET DTINTERFACEDEST = SYSDATE, STATUS = 0
                   WHERE IDINTERFACE = C_FORNECEDOR.IDINTERFACE;
               ELSE
                  V_CDMUNICIPIO := '';
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES (C_FORNECEDOR.IDINTERFACE, 'I', 1, SYSDATE, 1, 'C'||CHR(243)||'digo de exportacin '||C_FORNECEDOR.CDMUNICIPIOP || ', relacionado a el proveedor ' || C_FORNECEDOR.CDFORNECEDOR  || ' - ' ||  C_FORNECEDOR.NMFANTFORNE || ', n'||CHR(227)||'no registrado en el sistema Teknisa.');

                  UPDATE USR_SAP_FORNECEDOR SET STATUS = 2
                   WHERE IDINTERFACE = C_FORNECEDOR.IDINTERFACE;
               END IF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDMUNICIPIO := '';
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES (C_FORNECEDOR.IDINTERFACE, 'I', 1, SYSDATE, 1, 'C'||CHR(243)||'digo de exportacin '||C_FORNECEDOR.CDMUNICIPIOP || ', relacionado a el proveedor ' || C_FORNECEDOR.CDFORNECEDOR  || ' - ' ||  C_FORNECEDOR.NMFANTFORNE || ', n'||CHR(227)||'no registrado en el sistema Teknisa.');

                  UPDATE USR_SAP_FORNECEDOR SET STATUS = 2
                   WHERE IDINTERFACE = C_FORNECEDOR.IDINTERFACE;
            END;
         ELSE
            INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES (C_FORNECEDOR.IDINTERFACE, 'I', 1, SYSDATE, 1, 'Sigla de el estado '|| C_FORNECEDOR.SGESTADOP|| ', relacionado a el proveedor ' || C_FORNECEDOR.CDFORNECEDOR  || ' - ' ||  C_FORNECEDOR.NMFANTFORNE || ', n'||CHR(227)||'no registrado en el sistema Teknisa.');

            UPDATE USR_SAP_FORNECEDOR SET STATUS = 2
             WHERE IDINTERFACE = C_FORNECEDOR.IDINTERFACE;
         END IF;
      ELSE
         INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
         VALUES (C_FORNECEDOR.IDINTERFACE, 'I', 1, SYSDATE, 1, 'C'||CHR(243)||'digo do pa'||CHR(237)||'s '||C_FORNECEDOR.CDPAISP ||', relacionado a el proveedor ' || C_FORNECEDOR.CDFORNECEDOR  || ' - ' ||  C_FORNECEDOR.NMFANTFORNE || ', n'||CHR(227)||'no registrado en el sistema Teknisa.');

         UPDATE USR_SAP_FORNECEDOR SET STATUS = 2
          WHERE IDINTERFACE = C_FORNECEDOR.IDINTERFACE;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CCH_IMPORTA_FORNECEDOR_SAP','6.49.044'); END;
/
