function logIntegracaoController (ScreenService, General, templateManager, MessageService) {
    
    this.filterProduto = function(widget){
        var widProdRemessa = templateManager.container.getWidget('produtoPorRemessa');
        var prodini;
        var prodfim;
        if(widget.appliedFilter != undefined){
           prodini = widget.appliedFilter.FILTER_ROW.PRODINI;
           prodfim = widget.appliedFilter.FILTER_ROW.PRODFIM;

        }
        var filter = [
            {
                "name": "NRREMESSA",
                "operator": "=",
                "value": widProdRemessa.currentRow.NRREMESSA
            },
            {
                "name": "PRODINI",
                "operator": "=",
                "value": prodini
            },
            {
                "name": "PRODFIM",
                "operator": "=",
                "value": prodfim
            }
        ];
        widget.dataSourceFilter = filter;
        widget.reload();
    };
    
    
    this.filterRemessa = function(widget){
        var widRemessaProd = templateManager.container.getWidget('remessaPorProduto');
        
        var filter = [
            {
                "name": "CDPRODUTO",
                "operator": "=",
                "value": widRemessaProd.currentRow.CDPRODUTO
            }
        ];
        widget.dataSourceFilter = filter;
        widget.reload();
    };
    
    this.filterRemessaPorProduto = function(args){
        var filterRow = args.e.preference.FILTER_ROW;
        var prodIni = filterRow.NMPRODINI ? filterRow.PRODINI : 0;
        var prodFin = filterRow.NMPRODFIM ? filterRow.PRODFIM + 'z' : 'zzzzzzzzzz';
        // args.e.preference.CUSTOM_FILTER_ROW = {
        //     "PRODINI": prodIni,
        //     "PRODFIM": prodFin,
        // };
        templateManager.container.getWidget('remessaPorProduto').dataSourceFilter = [
            {
                "name": "PRODINI",
                "operator": "=",
                "value": prodIni
            },
            {
                "name": "PRODFIM",
                "operator": "=",
                "value": prodFin
            }
        ];
    };
    
    this.comparaProdutos = function(widget, field){
        var currentRow = widget.currentRow;
        if (currentRow.PRODINI && currentRow.PRODFIM && !General.comparaPratoProduto(currentRow.PRODINI, currentRow.PRODFIM, getLocalVar('CDPICTPROD'))) {
            MessageService.showMessageByCode('PRODINIFINMENORIGUAL');
            currentRow[field.name] = "";
        } 
        this.verifyProductRequired(widget);
    };
    
    this.verifyProductRequired = function(widget){
        var prodIni = widget.getField('NMPRODINI');
        var prodFin = widget.getField('NMPRODFIM');
        
        if(widget.currentRow.NMPRODINI || widget.currentRow.NMPRODFIM){
            prodIni.validations = {
                "required": true
            };
            prodFin.validations = {
                "required": true
            };
        } else {
            prodIni.validations = {};
            prodFin.validations = {};
        }
    };
    
    this.showProduto = function(widget){
      var tabProduto = templateManager.container.getWidget('tabbedProduto');
      var widProduto = templateManager.container.getWidget('produtos');
      ScreenService.openSwipe(tabProduto);
      this.filterProduto(widProduto);
    };
    
    this.showRemessas = function(widget){
      var tabRemessa = templateManager.container.getWidget('tabbedRemessa');
      var widRemessa = templateManager.container.getWidget('remessas');
      ScreenService.openSwipe(tabRemessa);
      this.filterRemessa(widRemessa);
    };
    
    this.back = function(widget){
      var wid;
      if(widget.name == "produtos")wid = templateManager.container.getWidget('produtoPorRemessa');
      else wid = templateManager.container.getWidget('remessaPorProduto');
      ScreenService.goBack();
      wid.activate();
    };
    
    this.setDataInterval = function(field,widget){
        widget.getField('DTDE').setValue(field.value().start);
        widget.getField('DTATE').setValue(field.value().end);
        
    };
    
    this.filterProdutoPorRemessa = function(args) {
        var filterRow = args.e.preference.FILTER_ROW;
        
    	args.e.preference.CUSTOM_FILTER_ROW = {
            "DTDE": filterRow.DTINTERVAL.start,
            "DTATE": filterRow.DTINTERVAL.end,
        };
    };
}
Configuration(function (ContextRegister) {
	ContextRegister.register('logIntegracaoController', logIntegracaoController);
});